#ifndef __BASE64_H__
#define __BASE64_H__

/* ==================================================================
  BASE64_encode
    주어진 문자열을 base64로 encoding한다.(= padding추가)
  parameter
    dest : base64 encoding한 데이터를 저장함
    src : base64 encoding할 데이터
    src_len : encoding할 데이터의 길이
  return
    0 이상 : encoding된 데이터의 길이(0 또는 4의 배수)
    -1 이하 : 오류
       -1 : 문자열의 길이가 -값으로 설정됨
================================================================== */
int BASE64_encode(char* dest, int dest_size, const unsigned char* src, size_t src_len);

/* ==================================================================
  BASE64_decode
    Base64로 encoding된 데이터를 decoding한다.
  parameter
    dest : decoding 결과를 저장할 buffer
    src : decoding할 데이터(base64 encoding된 데이터)
    src_len : decoding할 데이터의 길이(4의 배수이어야 함)
  return
    0 이상 : decoding된 데이터의 길이
    -1 : decoding할 data의 길이가 4의 배수가 아님
    -2 : decoding data가 base64 규칙이 아님
================================================================== */
int BASE64_decode(unsigned char* dest, int dest_size, const char* src, size_t src_len);

#endif
